package explicit.graphviz;

import java.util.BitSet;

public class MarkStateSetDecorator implements Decorator
{
	private BitSet set;
	private String fillColor = "#cccccc";

	public MarkStateSetDecorator(BitSet set)
	{
		this.set = set;
	}

	public MarkStateSetDecorator(BitSet set, String fillColor)
	{
		this.set = set;
		this.fillColor = fillColor;
	}

	public Decoration decorateState(int state, Decoration d)
	{
		if (set.get(state)) {
			d.attributes().put("style", "filled");
			d.attributes().put("fillcolor", fillColor);
		}
		return d;
	}

}
