package explicit.graphviz;

import explicit.rewards.MCRewards;
import explicit.rewards.MDPRewards;
import explicit.rewards.Rewards;

public class ShowRewardDecorator implements Decorator
{
	private Rewards rewards;

	public ShowRewardDecorator(explicit.rewards.Rewards rewards)
	{
		this.rewards = rewards;
	}

	public Decoration decorateState(int state, Decoration d)
	{
		double reward = 0;
		if (rewards instanceof MCRewards) {
			reward = ((MCRewards)rewards).getStateReward(state);
		} else if (rewards instanceof MDPRewards) {
			reward = ((MDPRewards)rewards).getStateReward(state);
		}
		if (reward == 0) {
			return d;
		}

		String label = d.getEffectiveValue("label");
		label += "\\n+" + reward; 
		d.setLabel(label);
		return d;
	}

	public Decoration decorateTransition(int state, int choice, Decoration d)
	{
		if (!(rewards instanceof MDPRewards)) {
			return d;
		}
		double reward = ((MDPRewards)rewards).getTransitionReward(state, choice);
		if (reward == 0) {
			return d;
		}

		String label = d.getEffectiveValue("label");
		label += "\\n+" + reward; 
		d.setLabel(label);
		return d;
	}

}