package explicit.graphviz;

import java.util.List;

import explicit.rewards.MCRewards;
import explicit.rewards.MDPRewards;
import explicit.rewards.StateRewards;

public class ShowStateRewardsDecorator implements Decorator
{
	private List<StateRewards> rewards;

	public ShowStateRewardsDecorator(List<explicit.rewards.StateRewards> rewards)
	{
		this.rewards = rewards;
	}

	public Decoration decorateState(int state, Decoration d)
	{
		boolean allZero = true;
	
		for (StateRewards rew : rewards) {
			double reward = 0;
			if (rew instanceof MCRewards) {
				reward = ((MCRewards)rewards).getStateReward(state);
			} else if (rew instanceof MDPRewards) {
				reward = ((MDPRewards)rewards).getStateReward(state);
			}
			if (reward != 0) {
				allZero = false;
				break;
			}
		}
		if (allZero)
			return d;

		String values = "";
		for (StateRewards rew : rewards) {
			double reward = 0;
			if (rew instanceof MCRewards) {
				reward = ((MCRewards)rewards).getStateReward(state);
			} else if (rew instanceof MDPRewards) {
				reward = ((MDPRewards)rewards).getStateReward(state);
			}
			if (!values.isEmpty())
				values += ",";
			values += reward;
		}

		String label = d.getEffectiveValue("label");
		label += "\\n(" + values+")"; 
		d.setLabel(label);
		return d;
	}
}